package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_day_luck_draw.git/db/model"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_day_luck_draw.git/md"
	zhios_day_luck_draw_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_day_luck_draw.git/utils"
	"errors"
	"time"
	"xorm.io/xorm"
)

func AddPeriodReward(sess *xorm.Session, req md.DayLuckDrawRewardReq) error {
	count, _ := sess.Where("uid=? and period=?", req.Uid, req.Period).Count(&model.DayLuckDrawPeriodReward{})
	if count > 0 {
		return nil
	}
	var data = &model.DayLuckDrawPeriodReward{
		Reward:     req.Reward,
		Uid:        zhios_day_luck_draw_utils.StrToInt(req.Uid),
		CreateTime: time.Now(),
		Period:     zhios_day_luck_draw_utils.StrToInt(req.Period),
		Lv:         zhios_day_luck_draw_utils.StrToInt(req.Lv),
	}
	one, err := sess.Insert(data)
	if one == 0 {
		return errors.New("失败")
	}
	if err != nil {
		return err
	}
	return nil
}

func GetDayLuckDrawPeriodRewardList(Db *xorm.Engine, parameter *md.DayLuckDrawPeriodRewardRequest) ([]*model.DayLuckDrawPeriodReward, int, error) {
	var list []*model.DayLuckDrawPeriodReward
	count := DayLuckDrawPeriodRewardGetCount(Db, parameter)
	session := Db.Where("")
	DayLuckDrawPeriodRewardSearchCondition(Db, session, parameter)
	//分页
	if zhios_day_luck_draw_utils.StrToInt(parameter.P) > 0 && zhios_day_luck_draw_utils.StrToInt(parameter.PageSize) > 0 {
		session = session.Limit(zhios_day_luck_draw_utils.StrToInt(parameter.PageSize), (zhios_day_luck_draw_utils.StrToInt(parameter.P)-1)*zhios_day_luck_draw_utils.StrToInt(parameter.PageSize))
	}
	//排序
	err := session.Desc("create_time").Find(&list)
	if err != nil {
		return nil, 0, err
	}
	return list, count, nil
}
func GetDayLuckDrawPeriodRewardSum(Db *xorm.Engine, uid int) float64 {
	sum, err := Db.Where("uid=?", uid).Sum(&model.DayLuckDrawPeriodReward{}, "reward")
	if err != nil {
		return 0
	}
	return sum
}
func DayLuckDrawPeriodRewardGetCount(Db *xorm.Engine, parameter *md.DayLuckDrawPeriodRewardRequest) int {
	var ord model.DayLuckDrawPeriodReward
	session := Db.Where("")
	DayLuckDrawPeriodRewardSearchCondition(Db, session, parameter)
	count, err := session.Count(&ord)
	if err != nil {
		return 0
	}
	return int(count)
}
func DayLuckDrawPeriodRewardSearchCondition(Db *xorm.Engine, session *xorm.Session, parameter *md.DayLuckDrawPeriodRewardRequest) {
	if parameter.Uid != "" {
		session = session.And("uid = ? ", parameter.Uid)
	}
	if parameter.Phone != "" {
		uid := 0
		mobile, _ := UserFindByMobile(Db, parameter.Phone)
		if mobile != nil {
			uid = mobile.Uid
		}
		session = session.And("uid = ? ", uid)
	}
	if parameter.StartTime != "" {
		session = session.And("create_time >=?", parameter.StartTime)
	}
	if parameter.EndTime != "" {
		session = session.And("create_time <=?", parameter.EndTime)
	}

}
