package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_day_luck_draw.git/db/model"
	zhios_day_luck_draw_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_day_luck_draw.git/utils"
	"time"
	"xorm.io/xorm"
)

func GetDayLuckDrawSetting(eg *xorm.Engine) *model.DayLuckDrawSetting {
	var data model.DayLuckDrawSetting
	get, err := eg.Get(&data)
	if err != nil {
		return nil
	}
	if get == false {
		one, err := eg.InsertOne(&data)
		if one == 0 || err != nil {
			return nil
		}
	}
	return &data
}
func CheckSetting(eg *xorm.Engine, pvd string) bool {
	setting := GetDayLuckDrawSetting(eg)
	if setting == nil {
		return false
	}
	now := time.Now().Unix()
	if setting.IsUse == 0 || setting.StartTime.IsZero() || setting.EndTime.IsZero() {
		return false
	}
	if now < setting.StartTime.Unix() || now > setting.EndTime.Unix() {
		return false
	}
	if setting.OrderSoruce == "mall" && pvd != "" && zhios_day_luck_draw_utils.InArr(pvd, []string{"mall_goods", "mall_group_buy", "mall_goods_user_lv", "super_group_buy", "mall_supply", "mall_group_own_buy"}) == false {
		return false
	}
	return true
}
func CheckSettingSess(sess *xorm.Session, pvd string) bool {
	setting := GetDayLuckDrawSettingSess(sess)
	if setting == nil {
		return false
	}
	now := time.Now().Unix()
	if setting.IsUse == 0 || setting.StartTime.IsZero() || setting.EndTime.IsZero() {
		return false
	}
	if now < setting.StartTime.Unix() || now > setting.EndTime.Unix() {
		return false
	}
	if setting.OrderSoruce == "mall" && pvd != "" && zhios_day_luck_draw_utils.InArr(pvd, []string{"mall_goods", "mall_group_buy", "mall_goods_user_lv", "super_group_buy", "mall_supply", "mall_group_own_buy"}) == false {
		return false
	}
	return true
}
func GetDayLuckDrawSettingSess(sess *xorm.Session) *model.DayLuckDrawSetting {
	var data model.DayLuckDrawSetting
	get, err := sess.Get(&data)
	if err != nil {
		return nil
	}
	if get == false {
		one, err := sess.InsertOne(&data)
		if one == 0 || err != nil {
			return nil
		}
	}
	return &data
}
func InsertDayLuckDrawSetting(eg *xorm.Engine, data *model.DayLuckDrawSetting) bool {
	if data.Id == 0 {
		one, err := eg.InsertOne(data)
		if one == 0 || err != nil {
			return false
		}
	} else {
		_, err := eg.Where("id=?", data.Id).AllCols().Update(data)
		if err != nil {
			return false
		}
	}
	return true
}
